//----------------------------------------------------------------------------------
// aviutlvOC eVl24 + 60i ebvǂɂtB^
// Copyright (c) 2005,2006  N099
//----------------------------------------------------------------------------------
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#define  _USE_MATH_DEFINES 
#include <math.h>
#include <limits.h>
#include <tchar.h>
#include <mmintrin.h>

#include "filter.h"

#define ARRAYSIZE(a)  (sizeof(a)/sizeof((a)[0]))
#define N_COMB_DATA  8
#define N_CACHE 5
#define SH_AMP 11

//---------------------------------------------------------------------
// func
//---------------------------------------------------------------------
int reconstruct_frame(PIXEL_YC *ycp, FILTER *fp, FILTER_PROC_INFO *fpip, int n);
int reconstruct_frame_e(FILTER *fp, FILTER_PROC_INFO *fpip);
int get_comb(FILTER *fp, FILTER_PROC_INFO *fpip, int n);
int comb_detect(PIXEL_YC *ycp, FILTER *fp, FILTER_PROC_INFO *fpip);
void make_coeff(int coeff[4], int off);
void field_mov(PIXEL_YC *dst, PIXEL_YC *src, FILTER *fp, FILTER_PROC_INFO *fpip);
void field_mov_sub(PIXEL_YC *dst, PIXEL_YC *src, FILTER *fp,
                   FILTER_PROC_INFO *fpip, int coeff[4]);
int lpf_v_11_mmx(PIXEL_YC *, PIXEL_YC *, int, int, int);
BOOL make_yc_coef(FILTER *fp, FILTER_PROC_INFO *fpip);
void cy(PIXEL_YC *ycp, int h, int left, int r, int sw, int fs);

//---------------------------------------------------------------------
// \
//---------------------------------------------------------------------
typedef struct tag_COMB_DATA {
  int comb;
  int n;
} COMB_DATA;

//---------------------------------------------------------------------
// global
//---------------------------------------------------------------------
COMB_DATA g_cd[N_COMB_DATA];
short *g_tbl_u = NULL;
short *g_tbl_v = NULL;

//---------------------------------------------------------------------
// tB^\̒`
//---------------------------------------------------------------------
#define TRACK_N 10
TCHAR *track_name[] =
{ "", "", "1/60", "Y", "C", "", "", "", "freq", "phase" };
int   track_default[] = { 320, 320, 0, 50, 70, 3, 1, 16, 704, 0 };
int   track_s[] = { 0, 0, -256,  0, 0, 0, 0, 0, 600, -180};
int   track_e[] = { 2048, 2048, 256, 256, 256, 8, 8, 32, 750, 180 };
enum
{ T_LEFT, T_WIDTH, T_60, T_TH_Y, T_TH_C, T_W_HI, T_W_MID, T_BOB, T_FRQ, T_PH };

#define CHECK_N 5
TCHAR *check_name[] = { "TFF", "͈͕\", "MONO", "C/Y", "LPF" };
int    check_default[] = { 1, 0, 0, 0, 1 };
enum { C_TFF, C_DISP, C_MONO, C_CY, C_LPF };

FILTER_DLL filter = {
  FILTER_FLAG_EX_INFORMATION, 0,0,
  "sct_v",
  TRACK_N, track_name, track_default, track_s, track_e,
  CHECK_N, check_name, check_default,
  func_proc,
  NULL,
  func_exit, //func_exit,
  func_update,
  NULL, NULL, NULL, NULL, 0,
  "sct_v by N099, ver1.2",
  NULL,  NULL,

};

//---------------------------------------------------------------------
//     tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
  memset(g_cd, 0, sizeof(g_cd));
  return &filter;
}

//---------------------------------------------------------------------
// IɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_exit( FILTER *fp )
{
  if(NULL != g_tbl_u){
    free(g_tbl_u);
    g_tbl_u = NULL;
  }
  if(NULL != g_tbl_v){
    free(g_tbl_v);
    g_tbl_v = NULL;
  }

  return TRUE;
}

//---------------------------------------------------------------------
// tB^֐
//---------------------------------------------------------------------
BOOL func_proc( FILTER *fp, FILTER_PROC_INFO *fpip )
{
  int i,j,r,left,tb;
  int n0, n1, c0, c1;
  PIXEL_YC *ycp;
  PIXEL_YC yc;
  COMB_DATA cd_tmp;
  static TCHAR buff[256];
  static int mv60;
  static int coeff[4];

  //LbVm
  if(!fp->exfunc->set_ycp_filtering_cache_size(fp, fpip->max_w, fpip->h, N_CACHE, 0))
    return FALSE;

  //ebv̈
  left = fp->track[T_LEFT];
  left = left<0 ? 0 : left;
  left = left>fpip->w ? fpip->w : left;
  r = left + fp->track[T_WIDTH];
  r = r<0 ? 0 : r;
  r = r>fpip->w ? fpip->w : r;
  
  //͈͕\
  if(fp->check[C_DISP] && !fp->exfunc->is_saving(fpip->editp)){
    for(i=0 ; i<fpip->h; ++i){
      ycp = fpip->ycp_edit + i*fpip->max_w + left;
      for(j=left ; j<r; ++j){
        yc = *ycp;
        yc.y = 4096 - yc.y;
        yc.cb = - yc.cb;
        yc.cr = - yc.cr;
        *ycp= yc;
        ++ycp;
      }
    }
    
    return TRUE;
  }

  //ebv t[č\z + Ȍo
  tb = (fp->track[T_BOB] * (fpip->w-(r-left)) * fpip->h)>>9;
  cd_tmp.n = cd_tmp.comb = 0; // č\p
  n0 = fpip->frame;
  c0 = get_comb(fp, fpip, n0);
  n1 = fpip->frame + 1;
  c1 = get_comb(fp, fpip, n1);

  if(c0>c1){
    cd_tmp.n = n1;
    cd_tmp.comb = c1;
    if(c1*4 >= tb){ //1tB[hT
      n0 = fpip->frame + 2;
      c0 = get_comb(fp, fpip, n0);
      if(c0<c1){// n0ōč\z
        cd_tmp.n = n0;
        cd_tmp.comb = c0;
      }
    }
  }else{// c1>=c0
    cd_tmp.n = n0;
    cd_tmp.comb = c0;
    if(c0*4 >= tb){ //1tB[hT
      n1 = fpip->frame - 1;
      c1 = get_comb(fp, fpip, n1);
      if(c1<c0){// n1ōč\z
        cd_tmp.n = n1;
        cd_tmp.comb = c1;
      }
    }
  }
  
  // cb_tmp ɂč\z
  // fpip->ycp_temp Ƀf[^u
  if(reconstruct_frame(fpip->ycp_temp, fp, fpip, cd_tmp.n))
    return FALSE;

  //ebvč\z
  // ܂ fpip->ycp_edit Ƀt[č\z
  if(reconstruct_frame_e(fp, fpip))
    return FALSE;

  // C->Yϊ
  if(fp->check[C_CY]){
    if(make_yc_coef(fp, fpip)){
      //t[(pair)ƃtB[hI[_[pbN
      int fs = ((fpip->frame)&2) | (fp->check[C_TFF]&1);
      cy(fpip->ycp_edit, fpip->h, left, r, fpip->max_w, fs);
    }
  }
  
  // ebv݂̈̂tB[h炵ŃRs[
  if(15&fp->track[T_60]){ //TusNZ
    //KvȂd݂vZ
    if(mv60 != fp->track[T_60]){
      _mm_empty();
      make_coeff(coeff, fp->track[T_60]);
      mv60 = fp->track[T_60];
    }
    field_mov_sub(fpip->ycp_temp, fpip->ycp_edit, fp, fpip, coeff);
  }else{
    field_mov(fpip->ycp_temp, fpip->ycp_edit, fp, fpip);
  }

  // tb 𒴂 lpf Ƀ`FbNꍇALPF
  if(cd_tmp.comb >= tb && fp->check[C_LPF]){
    lpf_v_11_mmx(fpip->ycp_edit, fpip->ycp_temp, fpip->h, fpip->max_w, fpip->w);
  }else{
    //ւ
    ycp = fpip->ycp_temp;
    fpip->ycp_temp = fpip->ycp_edit;
    fpip->ycp_edit = ycp;
  }
  
  //ʕ\
  if(!fp->exfunc->is_saving(fpip->editp)){
    _sntprintf(buff, ARRAYSIZE(buff), _T("%s num:%d comb:%d comb_th:%d"),
               filter.name, cd_tmp.n, cd_tmp.comb, tb);
    //_sntprintf(buff, ARRAYSIZE(buff), _T("%s t:%d/%d -1:%d -2:%d +1:%d +2:%d tb:%d"),
    //           filter.name, cd_tmp.n, cd_tmp.comb, get_comb(fp, fpip, cd_tmp.n-1),
    //           get_comb(fp, fpip, cd_tmp.n-2), get_comb(fp, fpip, cd_tmp.n+1),
    //           get_comb(fp, fpip, cd_tmp.n+2), tb);
    buff[ ARRAYSIZE(buff) - 1] = 0;
    SetWindowText(fp->hwnd, buff);
  }

  // ɂ
  if(fp->check[C_MONO] && !fp->check[C_CY]){
    for(i=0 ; i<fpip->h; ++i){
      ycp = fpip->ycp_edit + i*fpip->max_w + left;
      for(j=left ; j<r; ++j){
        yc.y = ycp->y;
        yc.cb = 0;
        yc.cr = 0;
        *ycp= yc;
        ++ycp;
      }
    }
  }

  
  return TRUE;
}

// ݒ肪ύXꂽƂ
//
BOOL func_update( FILTER *fp,int status )
{
  memset(g_cd, 0, sizeof(g_cd));

  return TRUE;
}

// t[č\z
// n-1 Ԗڂ̃t[Ƃ
int reconstruct_frame(PIXEL_YC *ycp, FILTER *fp, FILTER_PROC_INFO *fpip, int n)
{
  int i, base;
  PIXEL_YC *ycp0, *ycp1, *src, *dst;

  //͈͊Õt[ɂĂ 1 Ԃ
  if(n<=0 || n>=fpip->frame_n)
    return 1;
  
  // base == 0 : gbvtB[h
  // base == 1 : {gij
  base = 1&(n^(fp->check[C_TFF]));

  ycp0 = fp->exfunc->get_ycp_filtering_cache_ex(fp, fpip->editp, n-1, NULL, NULL);
  ycp1 = fp->exfunc->get_ycp_filtering_cache_ex(fp, fpip->editp, n,   NULL, NULL);
  if(ycp0 && ycp1){
    for(i=0 ; i<fpip->h-1; i+=2){
      src = ycp0 + (i+base)*fpip->max_w;
      dst = ycp  + (i+base)*fpip->max_w;
      memcpy(dst, src, fpip->max_w*sizeof(PIXEL_YC));
    }
    for(i=1 ; i<fpip->h; i+=2){
      src = ycp1 + (i-base)*fpip->max_w;
      dst = ycp  + (i-base)*fpip->max_w;
      memcpy(dst, src, fpip->max_w*sizeof(PIXEL_YC));
    }

    // I
    return 0;
  }

  //LbVȂ
  return 2;
}

// t[č\z
// ebvč\ẑ fpip->ycp_edit Ƀt[Č
int reconstruct_frame_e(FILTER *fp, FILTER_PROC_INFO *fpip)
{
  int i,k, base;
  PIXEL_YC *ycp0, *src, *dst;
  
  // base == 0 : gbvtB[h
  // base == 1 : {gij
  base = 1&(fpip->frame^(~fp->check[C_TFF]));

  k = fpip->frame + (1 - 2*(1&fpip->frame));
  ycp0 = fp->exfunc->get_ycp_filtering_cache_ex(fp, fpip->editp, k, NULL, NULL);
  if(ycp0){
    for(i=1 ; i<fpip->h; i+=2){
      src = ycp0 + (i-base)*fpip->max_w;
      dst = fpip->ycp_edit  + (i-base)*fpip->max_w;
      memcpy(dst, src, fpip->max_w*sizeof(PIXEL_YC));
    }

    // I
    return 0;
  }

  //LbVȂ
  return 1;
}

// ol𓾂
// fpip->ycp_temp ꎞ̈Ɏgp
// n : rt[(n-1  n r)
int get_comb(FILTER *fp, FILTER_PROC_INFO *fpip, int n)
{
  int k;

  //͈͊Õt[ɂĂ INT_MAX Ԃ
  if(n<=0 || n>=fpip->frame_n)
    return INT_MAX;

  //LbVꂽʂɊYt[΂Ԃ
  k = n % N_COMB_DATA;
  if(g_cd[k].n == n)
    return g_cd[k].comb;

  //t[č\zĎȌo
  if(!reconstruct_frame(fpip->ycp_temp, fp, fpip, n)){
    //Ȍo
    g_cd[k].n = n;
    g_cd[k].comb = comb_detect(fpip->ycp_temp, fp, fpip);
    
  }else{ //t[č\zɎsƂ(ɂ͂Ȃ͂)
    g_cd[k].n = n;
    g_cd[k].comb = INT_MAX;
  }

  return g_cd[k].comb;
}

// Ȍo
// ƒtB^̌ʂdݕtĉZ
#define COMB_GAIN 2
int comb_detect(PIXEL_YC *ycp, FILTER *fp, FILTER_PROC_INFO *fpip)
{
  int i,j,w,left,ls;
  int sum, c_y, c_cr, c_cb;
  PIXEL_YC *src;
  short *ssrc;
  int th_y, th_c, itmp_h, itmp_m;
  
  //Ȃ̈
  left = fp->track[T_LEFT];
  left = left<0 ? 0 : left;
  left = left>fpip->w ? fpip->w : left;
  w = left + fp->track[T_WIDTH];
  w = w<0 ? 0 : w;
  w = w>fpip->w ? fpip->w : w;
  
  th_y = fp->track[T_TH_Y];
  th_c = fp->track[T_TH_C];
  ls = fpip->max_w * 3;
  sum = 0;
  for(i=2; i<fpip->h-2; ++i){
    src = ycp + i*fpip->max_w;
    for(j=0 ; j<left; ++j){
      //
      ssrc = (short *)src;
      
      //y
      itmp_h = (*ssrc * 6 - (*(ssrc - ls) + *(ssrc + ls)) * 4
                + *(ssrc - 2*ls) + *(ssrc + 2*ls)) >> (4 + COMB_GAIN);
      itmp_m = (*(ssrc - 2*ls) + *(ssrc + 2*ls) - (*ssrc * 2)) >> (2 + COMB_GAIN);
      c_y = fp->track[T_W_HI] * itmp_h + fp->track[T_W_MID] * itmp_m;
      ++ssrc;
      //cb
      itmp_h = (*ssrc * 6 - (*(ssrc - ls) + *(ssrc + ls)) * 4
                + *(ssrc - 2*ls) + *(ssrc + 2*ls)) >> (4 + COMB_GAIN);
      itmp_m = (*(ssrc - 2*ls) + *(ssrc + 2*ls) - (*ssrc * 2)) >> (2 + COMB_GAIN);
      c_cb = abs(fp->track[T_W_HI] * itmp_h + fp->track[T_W_MID] * itmp_m);
      ++ssrc;
      //cr
      itmp_h = (*ssrc * 6 - (*(ssrc - ls) + *(ssrc + ls)) * 4
                + *(ssrc - 2*ls) + *(ssrc + 2*ls)) >> (4 + COMB_GAIN);
      itmp_m = (*(ssrc - 2*ls) + *(ssrc + 2*ls) - (*ssrc * 2)) >> (2 + COMB_GAIN);
      c_cr = abs(fp->track[T_W_HI] * itmp_h + fp->track[T_W_MID] * itmp_m);

      if(c_y >= th_y || c_cb >= th_c || c_cr >= th_c){
        ++sum;
      }
      
      ++src;
    }
    for( ; j<w; ++j){
      //^񒆁iȂ̈j
      ++src;
    }
    for( ; j<fpip->w; ++j){
      //E
      ssrc = (short *)src;
      
      //y
      itmp_h = (*ssrc * 6 - (*(ssrc - ls) + *(ssrc + ls)) * 4
                + *(ssrc - 2*ls) + *(ssrc + 2*ls)) >> (4 + COMB_GAIN);
      itmp_m = (*(ssrc - 2*ls) + *(ssrc + 2*ls) - (*ssrc * 2)) >> (2 + COMB_GAIN);
      c_y = fp->track[T_W_HI] * itmp_h + fp->track[T_W_MID] * itmp_m;
      ++ssrc;
      //cb
      itmp_h = (*ssrc * 6 - (*(ssrc - ls) + *(ssrc + ls)) * 4
                + *(ssrc - 2*ls) + *(ssrc + 2*ls)) >> (4 + COMB_GAIN);
      itmp_m = (*(ssrc - 2*ls) + *(ssrc + 2*ls) - (*ssrc * 2)) >> (2 + COMB_GAIN);
      c_cb = abs(fp->track[T_W_HI] * itmp_h + fp->track[T_W_MID] * itmp_m);
      ++ssrc;
      //cr
      itmp_h = (*ssrc * 6 - (*(ssrc - ls) + *(ssrc + ls)) * 4
                + *(ssrc - 2*ls) + *(ssrc + 2*ls)) >> (4 + COMB_GAIN);
      itmp_m = (*(ssrc - 2*ls) + *(ssrc + 2*ls) - (*ssrc * 2)) >> (2 + COMB_GAIN);
      c_cr = abs(fp->track[T_W_HI] * itmp_h + fp->track[T_W_MID] * itmp_m);

      if(c_y >= th_y || c_cb >= th_c || c_cr >= th_c){
        ++sum;
      }
      
      ++src;
    }
  }

  return sum;
}

// TusNZړp̌WvZ
// 1<<15 ̌Œ菬
void make_coeff(int coeff[4], int off)
{
  int i;
  double d0, d1;
  double c[4];
  double sum;
  static const double pi = M_PI;

  off &= 15;
  if(0 == off){
    coeff[0] = 1;
    coeff[1] = coeff[2] = coeff[3] = 0;

    return;
  }
  
  d0 = off*pi/32.0;
  d0 = sin(d0)/d0;
  d1 = off*pi/16.0;
  d1 = sin(d1)/d1;
  c[0] = d1*d0;

  d0 = (16-off)*pi/32.0;
  d0 = sin(d0)/d0;
  d1 = (16-off)*pi/16.0;
  d1 = sin(d1)/d1;
  c[1] = d1*d0;

  d0 = (16+off)*pi/32.0;
  d0 = sin(d0)/d0;
  d1 = (16+off)*pi/16.0;
  d1 = sin(d1)/d1;
  c[2] = d1*d0;

  d0 = (32-off)*pi/32.0;
  d0 = sin(d0)/d0;
  d1 = (32-off)*pi/16.0;
  d1 = sin(d1)/d1;
  c[3] = d1*d0;
  
  sum = c[0] + c[1] + c[2] + c[3];
  for(i=0; i<4; ++i){
    coeff[i] = (int)floor(((c[i] / sum) * (1<<15)) + 0.5);
  }
}

//tB[ḧړ
// sNZPʂł̈ړ
void field_mov(PIXEL_YC *dst, PIXEL_YC *src, FILTER *fp, FILTER_PROC_INFO *fpip)
{
  int i,j,k,w, base;
  int left = fp->track[T_LEFT];
  int up, dn;
  PIXEL_YC *src0 = src;
  PIXEL_YC *src1;
  PIXEL_YC *dst0 = dst;
  PIXEL_YC yc;

  //[̈O̎͂̂܂ܕԂ
  if(left < 0 || left >= fpip->w)
    return;

  //ebv̈
  w = left + fp->track[T_WIDTH];
  w = w<0 ? 0 : w;
  w = w>fpip->w ? fpip->w : w;
  
  // base == 0 : gbvtB[h
  // base == 1 : {gij
  base = 1&(fpip->frame^(~fp->check[C_TFF]));
  k = (fp->track[T_60]/16)*2;
  
  if(base){
    for(i=0 ; i<fpip->h; ++i){
      dst = dst0 + i*fpip->max_w + left;
      if(i&1){
        src = src0 + i*fpip->max_w + left;
        memcpy(dst, src, (w-left)*sizeof(PIXEL_YC));
      }else{
        if(i+k<0 || i+k>=fpip->h){ //Qƌ͈͊O
          up = i-1>=0 ? i-1 : i+1;
          dn = i+1>=fpip->h ? i-1 : i+1;
          src  = src0 + up*fpip->max_w + left;
          src1 = src0 + dn*fpip->max_w + left;
          for(j=0 ; j<w-left; ++j){
            //̃tB[hŕ(bob)
            yc.y = (src->y + src1->y + 1)/2;
            yc.cb = (src->cb + src1->cb + 1)/2;
            yc.cr = (src->cr + src1->cr + 1)/2;
            *dst = yc;
            ++dst;
            ++src;
            ++src1;
          }
        }else{
          src = src0 + (i+k)*fpip->max_w + left;
          memcpy(dst, src, (w-left)*sizeof(PIXEL_YC));
        }
      }
    }
  }else{
    for(i=0 ; i<fpip->h; ++i){
      dst = dst0 + i*fpip->max_w + left;
      if(i&1){
        if(i-k<0 || i-k>=fpip->h){ //Qƌ͈͊O
          up = i-1>=0 ? i-1 : i+1;
          dn = i+1>=fpip->h ? i-1 : i+1;
          src  = src0 + up*fpip->max_w + left;
          src1 = src0 + dn*fpip->max_w + left;
          for(j=0 ; j<w-left; ++j){
            //̃tB[hŕ(bob)
            yc.y = (src->y + src1->y + 1)/2;
            yc.cb = (src->cb + src1->cb + 1)/2;
            yc.cr = (src->cr + src1->cr + 1)/2;
            *dst = yc;
            ++dst;
            ++src;
            ++src1;
          }
        }else{
          src = src0 + (i-k)*fpip->max_w + left;
          memcpy(dst, src, (w-left)*sizeof(PIXEL_YC));
        }
      }else{
        src = src0 + i*fpip->max_w + left;
        memcpy(dst, src, (w-left)*sizeof(PIXEL_YC));
      }
    }
  }
}

//tB[ḧړ
// 1/16sNZPʂł̈ړ
void field_mov_sub(PIXEL_YC *dst, PIXEL_YC *src, FILTER *fp,
                   FILTER_PROC_INFO *fpip, int coeff[4])
{
  int i,j,k,w, base;
  int left = fp->track[T_LEFT];
  int up, dn;
  int l0,l1,l2,l3;
  PIXEL_YC *src0 = src;
  PIXEL_YC *src1;
  PIXEL_YC *dst0 = dst;
  PIXEL_YC yc;

  //[̈O̎͂̂܂ܕԂ
  if(left < 0 || left >= fpip->w)
    return;
  
  //ebv̈
  w = left + fp->track[T_WIDTH];
  w = w<0 ? 0 : w;
  w = w>fpip->w ? fpip->w : w;
  
  // base == 0 : gbvtB[h
  // base == 1 : {gij
  base = 1&(fpip->frame^(~fp->check[C_TFF]));
  k = (fp->track[T_60]/16)*2;
  if(fp->track[T_60]>0) k+=2;
  
  if(base){
    for(i=0 ; i<fpip->h; ++i){
      dst = dst0 + i*fpip->max_w + left;
      if(i&1){
        src = src0 + i*fpip->max_w + left;
        memcpy(dst, src, (w-left)*sizeof(PIXEL_YC));
      }else{
        if(i+k<0 || i+k>=fpip->h){ //Qƌ͈͊O
          up = i-1>=0 ? i-1 : i+1;
          dn = i+1>=fpip->h ? i-1 : i+1;
          src  = src0 + up*fpip->max_w + left;
          src1 = src0 + dn*fpip->max_w + left;
          for(j=0 ; j<w-left; ++j){
            //̃tB[hŕ(bob)
            yc.y = (src->y + src1->y + 1)/2;
            yc.cb = (src->cb + src1->cb + 1)/2;
            yc.cr = (src->cr + src1->cr + 1)/2;
            *dst = yc;
            ++dst;
            ++src;
            ++src1;
          }
        }else{
          l0 = i+k-2>=0 ? i+k-2 :  i+k;
          l1 = i+k;
          l2 = i+k+2<fpip->h ? i+k+2 : i+k;
          l3 = i+k+4<fpip->h ? i+k+4 : l2;
          l0 *= fpip->max_w;
          l1 *= fpip->max_w;
          l2 *= fpip->max_w;
          l3 *= fpip->max_w;
          src = src0 + left;
          for(j=0 ; j<w-left; ++j){
            yc.y  = ((1<<14) + coeff[0]*(src+l0)->y + coeff[1]*(src+l1)->y
                     + coeff[2]*(src+l2)->y + coeff[3]*(src+l3)->y)>>15;
            yc.cb = ((1<<14) + coeff[0]*(src+l0)->cb + coeff[1]*(src+l1)->cb
                     + coeff[2]*(src+l2)->cb + coeff[3]*(src+l3)->cb)>>15;
            yc.cr = ((1<<14) + coeff[0]*(src+l0)->cr + coeff[1]*(src+l1)->cr
                     + coeff[2]*(src+l2)->cr + coeff[3]*(src+l3)->cr)>>15;
            *dst = yc;
            ++dst;
            ++src;
          }
        }
      }
    }
  }else{
    for(i=0 ; i<fpip->h; ++i){
      dst = dst0 + i*fpip->max_w + left;
      if(i&1){
        if(i-k<0 || i-k>=fpip->h){ //Qƌ͈͊O
          up = i-1>=0 ? i-1 : i+1;
          dn = i+1>=fpip->h ? i-1 : i+1;
          src  = src0 + up*fpip->max_w + left;
          src1 = src0 + dn*fpip->max_w + left;
          for(j=0 ; j<w-left; ++j){
            //̃tB[hŕ(bob)
            yc.y = (src->y + src1->y + 1)/2;
            yc.cb = (src->cb + src1->cb + 1)/2;
            yc.cr = (src->cr + src1->cr + 1)/2;
            *dst = yc;
            ++dst;
            ++src;
            ++src1;
          }
        }else{
          l1 = i-k-2>=0 ? i-k-2 :  i-k;
          l0 = i-k-4>=0 ? i-k-4 : l1;
          l2 = i-k;
          l3 = i-k+2<fpip->h ? i-k+2 : i-k;
          l0 *= fpip->max_w;
          l1 *= fpip->max_w;
          l2 *= fpip->max_w;
          l3 *= fpip->max_w;
          src = src0 + left;
          for(j=0 ; j<w-left; ++j){
            yc.y  = ((1<<14) + coeff[3]*(src+l0)->y + coeff[2]*(src+l1)->y
                     + coeff[1]*(src+l2)->y + coeff[0]*(src+l3)->y)>>15;
            yc.cb = ((1<<14) + coeff[3]*(src+l0)->cb + coeff[2]*(src+l1)->cb
                     + coeff[1]*(src+l2)->cb + coeff[0]*(src+l3)->cb)>>15;
            yc.cr = ((1<<14) + coeff[3]*(src+l0)->cr + coeff[2]*(src+l1)->cr
                     + coeff[1]*(src+l2)->cr + coeff[0]*(src+l3)->cr)>>15;
            *dst = yc;
            ++dst;
            ++src;
          }
        }
      }else{
        src = src0 + i*fpip->max_w + left;
        memcpy(dst, src, (w-left)*sizeof(PIXEL_YC));
      }
    }
  }
}

// 11tap LPF w/ MMX
int lpf_v_11_mmx(PIXEL_YC *dst, PIXEL_YC *src, int h, int max_w, int w)
{
  int i,j;
  int ht = 1;
  int hb = 1;
  int l0,l1,l2,l3,l4,l6,l7,l8,l9,la;
  short *src0, *src1, *src2, *src3, *src4, *src5;
  short *src6, *src7, *src8, *src9, *srca, *dst0;
  int tmp;
  __m64 s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, sa, c0, c1, c2;
  
  c0 = _mm_set_pi16(518, -1442, 518, -1442);
  c1 = _mm_set_pi16(-3993, 2693, -3993, 2693);
  c2 = _mm_set_pi16(27256, 4980, 27256, 4980);
  hb = h - hb;
  w  = w * (sizeof(PIXEL_YC) / sizeof(short));

  for(i=0; i<ht; i++){
    dst0 = (short *)(dst + i * max_w);
    src5 = (short *)(src + i * max_w);
    memcpy(dst0, src5, max_w * sizeof(PIXEL_YC));
  }
  for( ; i<hb; i++){
    dst0 = (short *)(dst + i  * max_w);
    src5 = (short *)(src + i  * max_w);
    if(i-5<ht || i+5>=hb){ //͈͊OQƂꍇ
      l4 = i>ht ? i-1 : ht;
      l6 = i<(hb-1) ? i+1 : hb-1;
      l3 = (i-1)>ht ? i-2 : l4;
      l7 = i<(hb-2) ? i+2 : l6;
      l2 = (i-2)>ht ? i-3 : l3;
      l8 = i<(hb-3) ? i+3 : l7;
      l1 = (i-3)>ht ? i-4 : l2;
      l9 = i<(hb-4) ? i+4 : l8;
      l0 = (i-4)>ht ? i-5 : l1;
      la = i<(hb-5) ? i+5 : l9;
     
      src0 = (short *)(src + l0 * max_w);
      src1 = (short *)(src + l1 * max_w);
      src2 = (short *)(src + l2 * max_w);
      src3 = (short *)(src + l3 * max_w);
      src4 = (short *)(src + l4 * max_w);
      src6 = (short *)(src + l6 * max_w);
      src7 = (short *)(src + l7 * max_w);
      src8 = (short *)(src + l8 * max_w);
      src9 = (short *)(src + l9 * max_w);
      srca = (short *)(src + la * max_w);
    }else{
      src0 = (short *)(src + (i-5) * max_w);
      src1 = (short *)(src + (i-4) * max_w);
      src2 = (short *)(src + (i-3) * max_w);
      src3 = (short *)(src + (i-2) * max_w);
      src4 = (short *)(src + (i-1) * max_w);
      src6 = (short *)(src + (i+1) * max_w);
      src7 = (short *)(src + (i+2) * max_w);
      src8 = (short *)(src + (i+3) * max_w);
      src9 = (short *)(src + (i+4) * max_w);
      srca = (short *)(src + (i+5) * max_w);
    }
    
    for(j=w; j>3; j-=4){
      //
      s0 = *(__m64 *)src0;
      sa = *(__m64 *)srca;
      s0 = _mm_adds_pi16(s0, sa);
      
      s1 = *(__m64 *)src1;
      s9 = *(__m64 *)src9;
      s1 = _mm_adds_pi16(s1, s9);

      s9 = _mm_unpackhi_pi16(s1, s0);
      s1 = _mm_unpacklo_pi16(s1, s0);

      s9 = _mm_madd_pi16(s9, c0);
      s1 = _mm_madd_pi16(s1, c0);
      
      sa = _mm_cmpeq_pi32(sa, sa);
      sa = _mm_srli_pi32(sa, 31);
      sa = _mm_slli_pi32(sa, 14);

      s9 = _mm_add_pi32(s9, sa);
      s1 = _mm_add_pi32(s1, sa);
      
      //
      s2 = *(__m64 *)src2;
      s8 = *(__m64 *)src8;
      s2 = _mm_adds_pi16(s2, s8);

      s3 = *(__m64 *)src3;
      s7 = *(__m64 *)src7;
      s3 = _mm_adds_pi16(s3, s7);
      
      s8 = _mm_unpackhi_pi16(s2, s3);
      s2 = _mm_unpacklo_pi16(s2, s3);

      s8 = _mm_madd_pi16(s8, c1);
      s2 = _mm_madd_pi16(s2, c1);

      s9 = _mm_add_pi32(s9, s8);
      s1 = _mm_add_pi32(s1, s2);

      //
      s4 = *(__m64 *)src4;
      s6 = *(__m64 *)src6;
      s4 = _mm_adds_pi16(s4, s6);
      
      s5 = *(__m64 *)src5;
      s6 = _mm_unpackhi_pi16(s4, s5);
      s4 = _mm_unpacklo_pi16(s4, s5);
      
      s6 = _mm_madd_pi16(s6, c2);
      s4 = _mm_madd_pi16(s4, c2);

      s9 = _mm_add_pi32(s9, s6);
      s1 = _mm_add_pi32(s1, s4);

      s9 = _mm_srai_pi32(s9, 15);
      s1 = _mm_srai_pi32(s1, 15);

      s1 = _mm_packs_pi32(s1, s9);
      *(__m64 *)dst0 = s1;

      src0 += 4;
      src1 += 4;
      src2 += 4;
      src3 += 4;
      src4 += 4;
      src5 += 4;
      src6 += 4;
      src7 += 4;
      src8 += 4;
      src9 += 4;
      srca += 4;
      dst0 += 4;
    }
    //̂
    for( ; j>0; --j){
      tmp = *src0 + *srca;
      tmp = (*src1 + *src9) * 1442 - (tmp * 518);
      tmp = (*src2 + *src8) * 2693 - tmp;
      tmp = (*src3 + *src7) * 3993 - tmp;
      tmp = (*src4 + *src6) * 4980 - tmp;
      *dst0 = (tmp + *src5 * 27256 + (1<<14)) >> 15;

      src0++;
      src1++;
      src2++;
      src3++;
      src4++;
      src5++;
      src6++;
      src7++;
      src8++;
      src9++;
      srca++;     
      dst0++;
    }
  }
  for( ; i<h; i++){
    dst0 = (short *)(dst + i * max_w);
    src5 = (short *)(src + i * max_w);
    memcpy(dst0, src5, max_w * sizeof(PIXEL_YC));
  }

  _mm_empty();

  return 0;
}

// C->Yč\p̌W
BOOL make_yc_coef(FILTER *fp, FILTER_PROC_INFO *fpip)
{
  int i;
  double d,ph;
  static int mw = -1;
  static int w = -1;
  static int phase = 360;
  static int freq = -1;
  const int amp = 1 << SH_AMP;

  if(NULL == g_tbl_v || NULL == g_tbl_u || mw != fpip->max_w){
    //e[up̃m
    func_exit(NULL);
    g_tbl_u = malloc(fpip->max_w * sizeof(PIXEL_YC));
    g_tbl_v = malloc(fpip->max_w * sizeof(PIXEL_YC));   
    if(NULL == g_tbl_u || NULL == g_tbl_v){
      func_exit(NULL);
      return FALSE;
    }
    mw = fpip->max_w;
  }

  if(phase != fp->track[T_PH] || freq != fp->track[T_FRQ] || w != fpip->w){
    //C->Yĕϊp̃LA
    ph = (fp->track[T_PH]/180.0)*M_PI; //ʑ
    d = fp->track[T_FRQ]/704.0; //704(720)pixle/line ŐK
    d = (d*3.579545*M_PI)/6.75; //Fcs:3.579545MHz Fs:6.75MHz
    for(i=0; i<fpip->w; ++i){
      //cb,cr -> u,v փXP[ϊ
      g_tbl_u[i] = (short)floor(amp * (1.772/2.03) * cos(d*i + ph) + 0.5); //Cb/U
      g_tbl_v[i] = (short)floor(amp * (1.402/1.14) * sin(d*i + ph) + 0.5); //Cr/V
    }
    phase = fp->track[T_PH];
    freq = fp->track[T_FRQ];
    w = fpip->w;
  }
  
  return TRUE;
}

//C->Yĕϊ
// ycpCvCXŒu
void cy(PIXEL_YC *ycp, int h, int left, int r, int sw, int fs)
{
  int i,j;
  int cr,cb;
  int s; //TuLA̕
  const int rnd = 1<<(SH_AMP-1);
  PIXEL_YC yc;
  PIXEL_YC *ycp0;

  s = fs&2 ? 1 : -1;
  fs &= 1;
  for(i=0 ; i<h; ++i){
    ycp0 = ycp + i*sw + left;
    if(0 == ((i+fs)&1)) s = -s;

    for(j=left ; j<r; ++j){
      yc = *ycp0;

      //J[TuLA|Č̐M𕜌
      cr = (yc.cr * s * g_tbl_v[j] + rnd)>>SH_AMP;
      cb = (yc.cb * s * g_tbl_u[j] + rnd)>>SH_AMP;
      
      yc.y = yc.y + cr + cb;
      yc.cb = 0;
      yc.cr = 0;
      
      *ycp0++ = yc;
    }
  }
}

